/************************************************************************/
/*                                                                      */
/*  MFLMATH header file                                                 */
/*                                                                      */
/*  Defines and function prototypes for high-speed integer math         */
/*                                                                      */
/*  Copyright 1989 by Robert B. Stout dba MicroFirm                     */
/*  All rights reserved                                                 */
/*                                                                      */
/*  Copyright 1986, 1987 by S.E. Margison                               */
/*                                                                      */
/*  Compiled by and for use with Zortech C/C++ 1.07 or later.           */
/*                                                                      */
/************************************************************************/

#ifndef MFL_MATH_H
#define MFL_MATH_H

#include <mfldefs.h>

#ifndef _Cdecl_
 #if __ZTC__ > 0x107
  #define CONST__ const
  #ifdef __STDC__
   #define _Cdecl_
  #else
   #define _Cdecl_ cdecl
  #endif
 #else
  #define CONST__
  #define _Cdecl_
 #endif
#endif

#if __ZTC__ > 0x107
 #if __cplusplus
  extern "C" {
 #endif
#endif

/************************************************************************/
/*                                                                      */
/*  CRC calculation functions                                           */
/*                                                                      */
/************************************************************************/

unsigned        _Cdecl_ crc16_clear(void),
                _Cdecl_ crc16_update(unsigned, unsigned char),
                _Cdecl_ crc16_finish(unsigned);

unsigned long   _Cdecl_ crc32_clear(void),
                _Cdecl_ crc32_update(unsigned long, unsigned char),
                _Cdecl_ crc32_finish(unsigned long);

/************************************************************************/
/*                                                                      */
/*  Integer math functions                                              */
/*                                                                      */
/************************************************************************/

int             _Cdecl_ isqrt(unsigned),
                _Cdecl_ isqrtr(unsigned),
                _Cdecl_ divmod(int, int, int*);

unsigned        _Cdecl_ divmodu(unsigned, unsigned, unsigned *);

long            _Cdecl_ lsqrt(unsigned long),
                _Cdecl_ lsqrtr(unsigned long),
                _Cdecl_ divmodl(long, long, long *);

unsigned long   _Cdecl_ divmodlu(unsigned long,
                                 unsigned long,
                                 unsigned long *);

#if __ZTC__ > 0x107
 #if __cplusplus
  }
 #endif
#endif

#endif /* MFL_MATH_H */
